﻿using System;
using CoreGraphics;
using Foundation;
using Syncfusion.SfCalendar.iOS;
using UIKit;

namespace CalendariOSTest
{
	public partial class ViewController : UIViewController
	{
	SFCalendar cal = new SFCalendar();	
		protected ViewController(IntPtr handle) : base(handle)
		{
			// Note: this .ctor should not contain any initialization logic.
		}

		public override void ViewDidLoad()
		{
			
			base.ViewDidLoad();

			cal.Appointments = getEnglishAppointments();
			cal.EnableInLine = true;
			cal.Delegate = new CalendarDelegate();
			View.AddSubview(cal);
			// Perform any additional setup after loading the view, typically from a nib.
		}

		NSMutableArray getEnglishAppointments()
		{
			NSDate today = new NSDate();
			NSMutableArray appCollection = new NSMutableArray();
			NSCalendar calendar = NSCalendar.CurrentCalendar;
			// Get the year, month, day from the date
			NSDateComponents components = calendar.Components(
				NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, today);
			// Set the hour, minute, second
			components.Hour = 10;
			components.Minute = 0;
			components.Second = 0;

			// Get the year, month, day from the date
			NSDateComponents endDateComponents = calendar.Components(NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, today);
			// Set the hour, minute, second
			endDateComponents.Hour = 12;
			endDateComponents.Minute = 0;
			endDateComponents.Second = 0;
			NSDate startDate1 = calendar.DateFromComponents(components);
			NSDate endDate1 = calendar.DateFromComponents(endDateComponents);
			SFAppointment appointment1 = new SFAppointment();
			appointment1.StartTime = startDate1;
			appointment1.EndTime = endDate1;
			components.Day = components.Day;
			endDateComponents.Day = endDateComponents.Day;
			appointment1.Subject = (NSString)"Going to park";
			appCollection.Add(appointment1);
			SFAppointment appointment12 = new SFAppointment();
			appointment12.StartTime = startDate1;
			appointment12.EndTime = endDate1;
			components.Day = components.Day;
			endDateComponents.Day = endDateComponents.Day;
			appointment12.Subject = (NSString)"Going to park";
			appCollection.Add(appointment12);
			Random randomNumber = new Random();

			for (int i = 0; i < 10; i++)
			{
				components.Hour = randomNumber.Next(10, 16);
				endDateComponents.Hour = components.Hour + randomNumber.Next(1, 3);
				NSDate startDate = calendar.DateFromComponents(components);
				NSDate endDate = calendar.DateFromComponents(endDateComponents);
				SFAppointment appointment = new SFAppointment();
				appointment.StartTime = startDate;
				appointment.EndTime = endDate;
				appointment.AllDay = true;
				components.Day = components.Day + 1;
				endDateComponents.Day = endDateComponents.Day + 1;
				appointment.Subject = (NSString)"Meeting";
				appCollection.Add(appointment);
			}
			return appCollection;
		}



		public override void DidReceiveMemoryWarning()
		{
			base.DidReceiveMemoryWarning();
			// Release any cached data, images, etc that aren't in use.
		}
	}

	public class CalendarDelegate : SFCalendarDelegate
	{
		
		public override void DidMonthChange(SFCalendar calendar, NSDate navigatedMonth, NSDate previuousMonth)
		{
				NSMutableArray appCollection = new NSMutableArray();
			for (int i = 0; i < 6; i++)
			{
				NSDate today = new NSDate();
				NSCalendar c = NSCalendar.CurrentCalendar;
				// Get the year, month, day from the date
				NSDateComponents components = c.Components(
					NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, navigatedMonth);
				// Set the hour, minute, second
				components.Hour = 10;
				components.Minute = 0;
				components.Second = 0;
				components.Day = components.Day + i;

				// Get the year, month, day from the date
				NSDateComponents endDateComponents = c.Components(NSCalendarUnit.Year | NSCalendarUnit.Month | NSCalendarUnit.Day, navigatedMonth);
				// Set the hour, minute, second
				endDateComponents.Hour = 12;
				endDateComponents.Minute = 0;
				endDateComponents.Second = 0;
				endDateComponents.Day = components.Day + i;
				NSDate startDate1 = c.DateFromComponents(components);
				NSDate endDate1 = c.DateFromComponents(endDateComponents);

				SFAppointment appointment1 = new SFAppointment();
				appointment1.StartTime = startDate1;
				appointment1.EndTime = endDate1;
				appointment1.Subject = (NSString)"Meeting";
				appCollection.Add(appointment1);
				calendar.Appointments = appCollection;
			}

		}

	}

}
